>From 7f08c7d43217f636fe8fdba1c6a0c232072d7475 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Michal=20=C5=A0ruba=C5=99?= <xsruba03@stud.fit.vutbr.cz>
Date: Wed, 20 Aug 2014 12:22:06 +0200
Subject: [PATCH] SUDO: Support the IPA schema

https://fedorahosted.org/sssd/ticket/1108

Sudo rules at IPA server are stored in IPA SUDO schema which is different from
native LDAP SUDO schema. Sudo is capable of processing only sudo rules in native
LDAP schema so the rules at IPA are exported into native LDAP schema. This is
done by the compat plugin and exported rules are stored in ou=SUDOers,$DC
container. Current implementation of IPA SUDO provider is just a simple wrapper
for LDAP SUDO provider which looks up rules in that container. So
there is no native support of IPA SUDO schema at SSSD side. This patch adds the
support for IPA schema.

Scope off the changes:
----------------------

Modified files:

src/providers/ipa/ipa_sudo.{c,h}
 - inicialization of periodical refreshes added + ipa sudo handler

src/providers/ldap/sdap.h
 - ipa sudo rule and ipa sudo commands attributes added

src/providers/ldap/ldap_opts.h
 - new maps for IPA SUDO rules and IPA SUDO commands added

src/providers/ldap/ldap_options.h
 - initialization of new IPA sudo maps

src/providers/ldap/sdap_async_sudo.c and src/providers/ldap/sdap_sudo.h
 - these functions and structures are used by both IPA and LDAP sudo provider so
   they are not static anymore
  - sdap_sudo_store_sudoers()
  - sdap_sudo_purge_sudoers()
  - sdap_sudo_set_usn()
  - struct sdap_sudo_ctx
  - struct sdap_sudo_refresh_state

Makefile.am

New files:

src/providers/ipa/ipa_async_sudo.{c,h}
 - asynchronous module that wraps functionality of LDAP SUDO Provider

src/providers/ipa/ipa_async_sudo_cmds.c{c,h}
 - asynchronous module which handles IPA SUDO commands

src/providers/ipa/ipa_async_sudo_hostgroups.{c,h}
 - asynchronous module which performs refresh of hostgroups that the IPA client
	 is member of

src/providers/ipa/ipa_sudo_export.{c,h}
 - this module handles export of sudo rules from IPA SUDO scheme into native
	 LDAP SUDO scheme

src/providers/ipa/ipa_sudo_refreshes.{c,h}
 - build LDAP and SYSDB filters
 - prepares parameters for specific kind of a refresh (full, smart, rules)
---
 Makefile.am                                   |   37 +-
 src/providers/ipa/ipa_async_sudo.c            |  322 ++++++++
 src/providers/ipa/ipa_async_sudo.h            |   41 +
 src/providers/ipa/ipa_async_sudo_cmds.c       |  311 ++++++++
 src/providers/ipa/ipa_async_sudo_cmds.h       |   39 +
 src/providers/ipa/ipa_async_sudo_hostgroups.c |  240 ++++++
 src/providers/ipa/ipa_async_sudo_hostgroups.h |   37 +
 src/providers/ipa/ipa_sudo.c                  |  288 ++++++-
 src/providers/ipa/ipa_sudo.h                  |   52 ++
 src/providers/ipa/ipa_sudo_export.c           | 1044 +++++++++++++++++++++++++
 src/providers/ipa/ipa_sudo_export.h           |   99 +++
 src/providers/ipa/ipa_sudo_refreshes.c        |  766 ++++++++++++++++++
 src/providers/ipa/ipa_sudo_refreshes.h        |   54 ++
 src/providers/ldap/ldap_options.c             |   20 +
 src/providers/ldap/ldap_opts.h                |   31 +
 src/providers/ldap/sdap.h                     |   35 +
 src/providers/ldap/sdap_async_sudo.c          |  170 ++--
 src/providers/ldap/sdap_sudo.c                |   10 +-
 src/providers/ldap/sdap_sudo.h                |   52 +-
 19 files changed, 3561 insertions(+), 87 deletions(-)
 create mode 100644 src/providers/ipa/ipa_async_sudo.c
 create mode 100644 src/providers/ipa/ipa_async_sudo.h
 create mode 100644 src/providers/ipa/ipa_async_sudo_cmds.c
 create mode 100644 src/providers/ipa/ipa_async_sudo_cmds.h
 create mode 100644 src/providers/ipa/ipa_async_sudo_hostgroups.c
 create mode 100644 src/providers/ipa/ipa_async_sudo_hostgroups.h
 create mode 100644 src/providers/ipa/ipa_sudo.h
 create mode 100644 src/providers/ipa/ipa_sudo_export.c
 create mode 100644 src/providers/ipa/ipa_sudo_export.h
 create mode 100644 src/providers/ipa/ipa_sudo_refreshes.c
 create mode 100644 src/providers/ipa/ipa_sudo_refreshes.h

diff --git a/Makefile.am b/Makefile.am
index 67077110588d9c746342f8cb69f942ebccf7fed4..00a7717bb7cbb39356c250c2cf756a2c6bbedc84 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -188,6 +188,7 @@ if HAVE_CMOCKA
         nestedgroups-tests \
         test_sss_idmap \
         test_ipa_idmap \
+        test_ipa_sudo_export \
         test_utils \
         ad_common_tests \
         dp_opt_tests \
@@ -1647,6 +1648,35 @@ sbus_internal_tests_LDADD = \
     libsss_debug.la \
     libsss_test_common.la
 
+test_ipa_sudo_export_SOURCES = \
+    src/tests/cmocka/test_ipa_sudo_export.c \
+    src/providers/ipa/ipa_async_sudo.c \
+    src/providers/ipa/ipa_async_sudo_cmds.c \
+    src/providers/ldap/sdap_async_sudo.c \
+    src/providers/ipa/ipa_sudo_export.c \
+    src/providers/ldap/sdap_sudo_cache.c \
+    src/util/debug.c
+test_ipa_sudo_export_CFLAGS = \
+    $(AM_CFLAGS)
+test_ipa_sudo_export_LDFLAGS = \
+    -Wl,-wrap,debug_fn \
+    -Wl,-wrap,be_is_offline \
+    -Wl,-wrap,sdap_id_op_create \
+    -Wl,-wrap,sdap_id_op_connect_send \
+    -Wl,-wrap,sdap_id_op_connect_recv \
+    -Wl,-wrap,sdap_id_op_handle \
+    -Wl,-wrap,sdap_get_generic_send \
+    -Wl,-wrap,sdap_get_generic_recv \
+    -Wl,-wrap,dp_opt_get_int \
+    -Wl,-wrap,_dp_opt_get_int \
+    -Wl,-wrap,build_attrs_from_map \
+    -Wl,-wrap,sdap_get_id_specific_filter
+test_ipa_sudo_export_LDADD = \
+    $(CMOCKA_LIBS) \
+    libsss_debug.la \
+    $(SSSD_INTERNAL_LTLIBS) \
+    libsss_test_common.la
+
 test_find_uid_SOURCES = \
     src/tests/cmocka/test_find_uid.c \
     src/util/find_uid.c \
@@ -2288,7 +2318,12 @@ endif
 
 if BUILD_SUDO
 libsss_ipa_la_SOURCES += \
-    src/providers/ipa/ipa_sudo.c
+    src/providers/ipa/ipa_sudo.c \
+    src/providers/ipa/ipa_sudo_refreshes.c \
+    src/providers/ipa/ipa_sudo_export.c \
+    src/providers/ipa/ipa_async_sudo.c \
+    src/providers/ipa/ipa_async_sudo_cmds.c \
+    src/providers/ipa/ipa_async_sudo_hostgroups.c
 endif
 
 if BUILD_SSH
diff --git a/src/providers/ipa/ipa_async_sudo.c b/src/providers/ipa/ipa_async_sudo.c
new file mode 100644
index 0000000000000000000000000000000000000000..ffb8b95e909f9b554a9e94dca96c710442cb7189
--- /dev/null
+++ b/src/providers/ipa/ipa_async_sudo.c
@@ -0,0 +1,322 @@
+/*
+    SSSD
+
+    IPA SUDO Provider
+
+    Authors:
+        MIchal Šrubař <xsruba03@stud.fit.vutbr.cz>
+
+    Copyright (C) 2014 MIchal Šrubař
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <errno.h>
+#include <talloc.h>
+#include <tevent.h>
+
+#include "providers/dp_backend.h"
+#include "providers/ldap/ldap_common.h"
+#include "providers/ldap/sdap.h"
+#include "providers/ldap/sdap_async.h"
+#include "providers/ldap/sdap_sudo.h"
+#include "providers/ldap/sdap_sudo_cache.h"
+#include "providers/ipa/ipa_async_sudo_cmds.h"
+#include "db/sysdb_sudo.h"
+
+static void ipa_sudo_sudoers_process(struct tevent_req *subreq);
+static void ipa_sudo_get_cmds_done(struct tevent_req *subreq);
+static void ipa_sudo_load_sudoers_finish(struct tevent_req *req, 
+                                         struct sdap_sudo_refresh_state *state,
+                                         struct sysdb_attrs **rules,
+                                         size_t count);
+
+struct tevent_req *ipa_sudo_refresh_send(TALLOC_CTX *mem_ctx,
+                                          struct be_ctx *be_ctx,
+                                          struct sdap_options *opts,
+                                          struct sdap_id_conn_cache *conn_cache,
+                                          const char *ldap_filter,
+                                          const char *sysdb_filter)
+{
+    struct tevent_req *req;
+    struct tevent_req *subreq;
+
+    /* use the same state structure as LDAP SUDO provider because we use LDAP
+     * provider to download sudo rules from IPA server */
+    struct sdap_sudo_refresh_state *state;
+    int ret = EOK;
+
+    req = tevent_req_create(mem_ctx, &state, struct sdap_sudo_refresh_state);
+    if (!req) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("tevent_req_create() failed\n"));
+        return NULL;
+    }
+
+    /* if we don't have a search filter, this request is meaningless */
+    if (ldap_filter == NULL) {
+        ret = EINVAL;
+        goto immediately;
+    }
+
+    state->be_ctx = be_ctx;
+    state->opts = opts;
+    state->sdap_op = NULL;
+    state->sdap_conn_cache = conn_cache;
+    state->sysdb = be_ctx->domain->sysdb;
+    state->domain = be_ctx->domain;
+    state->ldap_filter = talloc_strdup(state, ldap_filter);
+    state->sysdb_filter = talloc_strdup(state, sysdb_filter);
+    state->dp_error = DP_ERR_OK;
+    state->error = EOK;
+    state->highest_usn = NULL;
+    state->ldap_rules = NULL;
+    state->ldap_rules_count = 0;
+
+    /* if we don't have a LDAP search filter then this request is meaningless 
+     * although sysdb filter can be NULL for smart refresh */
+    if (state->ldap_filter == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("talloc_strdup() failed\n"));
+        ret = EINVAL;
+        goto immediately;
+    }
+
+    /* sysdb filter can be NULL at SMART REFRESH */
+    if (sysdb_filter != NULL && state->sysdb_filter == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("talloc_strdup() failed\n"));
+        ret = ENOMEM;
+        goto immediately;
+    }
+
+    DEBUG(SSSDBG_TRACE_FUNC, ("Giving control to LDAP SUDO provider to "
+                              "download IPA sudo rules\n"));
+
+    /* LDAP SUDO Provider won't be saving anything to sysdb so it doesn't need
+     * the sysdb filter */
+    subreq = sdap_sudo_refresh_send(state,
+                                    state->be_ctx,
+                                    state->opts,
+                                    state->sdap_conn_cache,
+                                    state->ldap_filter, "");
+    if (subreq == NULL) {
+        ret = ENOMEM;
+        goto immediately;
+    }
+
+    /* We'll receive sudo rules in IPA schema. We need to export those rules 
+     * into native LDAP sudo schema before we can store them into sysdb. */
+    tevent_req_set_callback(subreq, ipa_sudo_sudoers_process, req);
+
+    /* asynchronous processing */
+    return req;
+
+immediately:
+    if (ret == EOK) {
+        tevent_req_done(req);
+    } else {
+        tevent_req_error(req, ret);
+    }
+    tevent_req_post(req, be_ctx->ev);
+
+    return req;
+}
+
+int ipa_sudo_refresh_recv(TALLOC_CTX *mem_ctx,
+                           struct tevent_req *req,
+                           int *dp_error,
+                           int *error,
+                           char **usn,
+                           size_t *num_rules,
+                           struct sysdb_attrs ***rules)
+{
+    struct sdap_sudo_refresh_state *state;
+
+    state = tevent_req_data(req, struct sdap_sudo_refresh_state);
+
+    TEVENT_REQ_RETURN_ON_ERROR(req);
+
+    *dp_error = state->dp_error;
+    *error = state->error;
+
+    if (usn != NULL && state->highest_usn != NULL) {
+        *usn = talloc_steal(mem_ctx, state->highest_usn);
+    }
+
+    if (num_rules != NULL) {
+        *num_rules = state->num_rules;
+    }
+
+    if (rules != NULL) {
+        *rules = talloc_steal(mem_ctx, state->ldap_rules);
+    }
+
+    return EOK;
+}
+
+/* subreq -> req from sdap_sudo_refresh_send */
+static void ipa_sudo_sudoers_process(struct tevent_req *subreq)
+{
+    struct tevent_req *req;
+    struct sdap_sudo_refresh_state *state;
+    struct sysdb_attrs **ipa_rules;
+    size_t ipa_rules_count;
+    int ret = EOK;
+
+    /* callback data is req from ipa_sudo_refresh_send */
+    req = tevent_req_callback_data(subreq, struct tevent_req);
+    state = tevent_req_data(req, struct sdap_sudo_refresh_state);
+
+    ret = sdap_sudo_refresh_recv(state, subreq, &state->dp_error, &state->error, 
+                                 &state->highest_usn, 
+                                 &ipa_rules_count, &ipa_rules);
+
+    talloc_zfree(subreq);
+    if (ret != EOK || state->dp_error != DP_ERR_OK || state->error != EOK) {
+        tevent_req_done(req);
+        return;
+    }
+
+    if (ipa_rules == NULL && ipa_rules_count == 0) {
+        ipa_sudo_load_sudoers_finish(req, state, NULL, 0);
+        return;
+    }
+
+    subreq = ipa_sudo_get_cmds_send(state,
+                                    ipa_rules, 
+                                    ipa_rules_count, 
+                                    state->be_ctx, 
+                                    state->sdap_conn_cache,
+                                    state->opts);
+    if (subreq == NULL) {
+        tevent_req_error(req, ENOMEM);
+        return;
+    }
+
+    tevent_req_set_callback(subreq, ipa_sudo_get_cmds_done, req);
+}
+
+static void ipa_sudo_get_cmds_done(struct tevent_req *subreq)
+{
+    struct tevent_req *req;
+    struct sdap_sudo_refresh_state *state;
+    struct sysdb_attrs **attrs = NULL;
+    size_t count;
+    int ret = EOK;
+    int i;
+
+    /* req from ipa_sudo_refresh_send */
+    req = tevent_req_callback_data(subreq, struct tevent_req);
+    state = tevent_req_data(req, struct sdap_sudo_refresh_state);
+
+    /* steal EXPORTED sudoers and free IPA sudo commands req */
+    ret = ipa_sudo_get_cmds_recv(subreq, state, &count, &attrs);
+    talloc_zfree(subreq);
+    if (ret != EOK) {
+        tevent_req_error(req, ret);
+        return;
+    }
+
+    /* FIXME:
+     * Multiple search bases are handlel automatically by LDAP SUDO Provider but
+     * is it even possible to have multiple search bases with IPA?
+     */
+
+    /* add exported rules to result */
+    if (count > 0) {
+        state->ldap_rules = talloc_realloc(state, state->ldap_rules,
+                                           struct sysdb_attrs *,
+                                           state->ldap_rules_count + count);
+        if (state->ldap_rules == NULL) {
+            tevent_req_error(req, ENOMEM);
+            return;
+        }
+
+        for (i = 0; i < count; i++) {
+            state->ldap_rules[state->ldap_rules_count + i] = talloc_steal(
+                                                   state->ldap_rules, attrs[i]);
+        }
+
+        state->ldap_rules_count += count;
+    }
+
+    /* now we need to purge the sysdb and store the exported sudoers */
+    ipa_sudo_load_sudoers_finish(req, state, state->ldap_rules, 
+                                 state->ldap_rules_count);
+}
+
+/* req from ipa_sudo_refresh_send() */
+static void ipa_sudo_load_sudoers_finish(struct tevent_req *req, 
+                                         struct sdap_sudo_refresh_state *state,
+                                         struct sysdb_attrs **rules,
+                                         size_t count)
+{
+    bool in_transaction = false;
+    errno_t sret = EOK;
+    int ret = EOK;
+    time_t now;
+
+    /* start transaction */
+    ret = sysdb_transaction_start(state->sysdb);
+    if (ret != EOK) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("Failed to start transaction\n"));
+        goto done;
+    }
+    in_transaction = true;
+
+    /* purge cache */
+    ret = sdap_sudo_purge_sudoers(state->domain, state->sysdb_filter,
+                                  state->opts->ipa_sudorule_map, count, rules);
+    if (ret != EOK) {
+        goto done;
+    }
+
+    /* store rules */
+    now = time(NULL);
+    ret = sdap_sudo_store_sudoers(state, state->domain,
+                                  state->opts, count, rules,
+                                  state->domain->sudo_timeout, now,
+                                  &state->highest_usn);
+    if (ret != EOK) {
+        goto done;
+    }
+
+    /* commit transaction */
+    ret = sysdb_transaction_commit(state->sysdb);
+    if (ret != EOK) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("Failed to commit transaction\n"));
+        goto done;
+    }
+    in_transaction = false;
+
+    DEBUG(SSSDBG_TRACE_FUNC, ("Sudoers is successfully stored in cache\n"));
+
+    state->num_rules = count;
+
+done:
+    if (in_transaction) {
+        sret = sysdb_transaction_cancel(state->sysdb);
+        if (sret != EOK) {
+            DEBUG(SSSDBG_OP_FAILURE, ("Could not cancel transaction\n"));
+        }
+    }
+
+    /* finish req from ipa_sudo_refresh_send */
+    state->error = ret;
+    if (ret == EOK) {
+        state->dp_error = DP_ERR_OK;
+        tevent_req_done(req);
+    } else {
+        state->dp_error = DP_ERR_FATAL;
+        tevent_req_error(req, ret);
+    }
+}
diff --git a/src/providers/ipa/ipa_async_sudo.h b/src/providers/ipa/ipa_async_sudo.h
new file mode 100644
index 0000000000000000000000000000000000000000..f9b62d260c3b14aea68d18d9586828898597959e
--- /dev/null
+++ b/src/providers/ipa/ipa_async_sudo.h
@@ -0,0 +1,41 @@
+/*
+    SSSD
+
+    Authors:
+        Michal Šrubař <xsruba03@stud.fit.vutbr.cz>
+
+    Copyright (C) 2014 Michal Srubar
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef _IPA_ASYNC_SUDO_H_
+#define _IPA_ASYNC_SUDO_H_
+
+struct tevent_req *ipa_sudo_refresh_send(TALLOC_CTX *mem_ctx,
+                                          struct be_ctx *be_ctx,
+                                          struct sdap_options *opts,
+                                          struct sdap_id_conn_cache *conn_cache,
+                                          const char *ldap_filter,
+                                          const char *sysdb_filter);
+int ipa_sudo_refresh_recv(TALLOC_CTX *mem_ctx,
+                           struct tevent_req *req,
+                           int *dp_error,
+                           int *error,
+                           char **usn,
+                           size_t *num_rules,
+                           struct sysdb_attrs ***rules);
+
+#endif  // _IPA_ASYNC_SUDO_H_
diff --git a/src/providers/ipa/ipa_async_sudo_cmds.c b/src/providers/ipa/ipa_async_sudo_cmds.c
new file mode 100644
index 0000000000000000000000000000000000000000..a75a2e2d7726ddf6cc6c404daedaba1f67706e74
--- /dev/null
+++ b/src/providers/ipa/ipa_async_sudo_cmds.c
@@ -0,0 +1,311 @@
+/*
+    SSSD
+
+    Async IPA SUDO module which downloads sudo commands for IPA sudo rules.
+
+    Authors:
+
+        Michal Šrubař <xsruba03@stud.fit.vutbr.cz>
+
+    Copyright (C) 2014 Michal Šrubař
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "db/sysdb_sudo.h"
+#include "providers/ldap/sdap_async.h"
+#include "providers/ldap/sdap.h"
+#include "providers/ipa/ipa_common.h"
+#include "providers/ipa/ipa_sudo_export.h"
+#include "providers/ipa/ipa_sudo.h"
+
+static errno_t ipa_sudo_get_cmds_retry(struct tevent_req *req);
+static void ipa_sudo_get_cmds_connect_done(struct tevent_req *subreq);
+static void ipa_sudo_cmds_process(struct tevent_req *subreq);
+
+struct ipa_sudo_get_cmds_state {
+
+    struct be_ctx *be_ctx;
+    struct sdap_id_op *sdap_op;
+    struct sysdb_ctx *sysdb;
+    struct tevent_context *ev;
+    struct sdap_id_conn_cache *conn_cache;
+    struct sdap_options *opts;
+
+    const char *filter;     /* LDAP filter for IPA sudo commands */
+    const char *basedn;
+    const char **attrs;
+    int scope;
+    int timeout;
+
+    int dp_error;
+    int error;
+
+    struct sudo_rules *rules;
+};
+
+struct tevent_req *ipa_sudo_get_cmds_send(TALLOC_CTX *mem,
+                                          struct sysdb_attrs **ipa_rules,
+                                          int ipa_rules_count,
+                                          struct be_ctx *be_ctx,
+                                          struct sdap_id_conn_cache *conn_cache,
+                                          struct sdap_options *opts)
+{
+    struct ipa_sudo_get_cmds_state *state;
+    struct tevent_req *req;
+    errno_t ret = EOK;
+    errno_t cmds_ret = EOK;
+
+    req = tevent_req_create(mem, &state, struct ipa_sudo_get_cmds_state);
+    if (!req) {
+        DEBUG(SSSDBG_FATAL_FAILURE, "tevent_req_create() failed\n");
+        return NULL;
+    }
+
+    state->be_ctx = be_ctx;
+    state->sdap_op = NULL;
+    state->opts = opts;
+    state->sysdb = be_ctx->domain->sysdb;
+    state->ev = be_ctx->ev;
+    state->conn_cache = conn_cache;
+    state->filter = NULL;
+    state->basedn = talloc_strdup(state, IPA_SUDO_CMDS_BASEDN);
+    state->attrs = NULL;
+    state->scope = LDAP_SCOPE_SUBTREE;
+    state->timeout = dp_opt_get_int(opts->basic, SDAP_SEARCH_TIMEOUT);
+    state->dp_error = DP_ERR_OK;
+    state->error = EOK;
+
+    state->rules = talloc_zero(state, struct sudo_rules);
+    if (state->rules == NULL) {
+        DEBUG(SSSDBG_FATAL_FAILURE, "talloc_zero() failed\n");
+        ret = ENOMEM;
+        goto immediately;
+    }
+
+    state->rules->ipa_rules = talloc_steal(state->rules, ipa_rules);
+    state->rules->ipa_rules_count = ipa_rules_count;
+
+    if (state->basedn == NULL) {
+        DEBUG(SSSDBG_FATAL_FAILURE, "talloc_strdup() failed\n");
+        ret = ENOMEM;
+        goto immediately;
+    }
+ 
+    DEBUG(SSSDBG_TRACE_FUNC, "Getting commands for downloaded IPA SUDO rules\n");
+
+    cmds_ret = build_cmds_filter(state, state->sysdb, ipa_rules, 
+                                 ipa_rules_count, &(state->filter));
+    if (cmds_ret != ENOENT && cmds_ret != EOK) {
+        /* an error has occured */
+        ret = cmds_ret;
+        goto immediately;
+    }
+
+    /* EXPORT sudo rules but skip commands */
+    ret = export_sudoers(state, state->sysdb,
+                         state->rules->ipa_rules, 
+                         state->rules->ipa_rules_count, 
+                         &(state->rules->sudoers),
+                         &(state->rules->sudoers_count),
+                         &(state->rules->cmds_index),
+                         req);
+    if (ret != EOK) {
+        goto immediately;
+    } else if (ret == EOK && cmds_ret == ENOENT) {
+        /* ipa sudoers exported and there is no need to download any ipa 
+         * sudo commands */
+        goto immediately;
+    }
+
+    ret = ipa_sudo_get_cmds_retry(req);
+    if (ret == EAGAIN) {
+        return req;
+    }
+
+immediately:
+    if (ret == EOK) {
+        tevent_req_done(req);
+    } else {
+        tevent_req_error(req, ret);
+    }
+    tevent_req_post(req, state->ev);
+
+    return req;
+}
+
+int ipa_sudo_get_cmds_recv(struct tevent_req *req,
+                           TALLOC_CTX *mem_ctx,
+                           size_t *reply_count,
+                           struct sysdb_attrs ***reply)
+{
+    struct ipa_sudo_get_cmds_state *state;
+
+    state = tevent_req_data(req, struct ipa_sudo_get_cmds_state);
+
+    TEVENT_REQ_RETURN_ON_ERROR(req);
+
+    *reply_count = state->rules->sudoers_count;
+    *reply = talloc_steal(mem_ctx, state->rules->sudoers);
+
+    return EOK;
+}
+
+static errno_t ipa_sudo_get_cmds_retry(struct tevent_req *req)
+{
+    struct ipa_sudo_get_cmds_state *state;
+    struct tevent_req *subreq;
+    errno_t ret = EOK;
+
+    state = tevent_req_data(req, struct ipa_sudo_get_cmds_state);
+
+    if (be_is_offline(state->be_ctx)) {
+        state->dp_error = DP_ERR_OFFLINE;
+        state->error = EAGAIN;
+        return EOK;
+    }
+
+    if (state->sdap_op == NULL) {
+
+        state->sdap_op = sdap_id_op_create(state, state->conn_cache);
+        if (state->sdap_op == NULL) {
+            DEBUG(SSSDBG_CRIT_FAILURE, "sdap_id_op_create() failed\n");
+            state->dp_error = DP_ERR_FATAL;
+            state->error = EIO;
+            return EIO;
+        }
+    }
+
+    subreq = sdap_id_op_connect_send(state->sdap_op, state, &ret);
+    if (subreq == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "sdap_id_op_connect_send() failed: %d(%s)\n",
+                                   ret, strerror(ret));
+        talloc_zfree(state->sdap_op);
+        state->dp_error = DP_ERR_FATAL;
+        state->error = ret;
+        return ret;
+    }
+
+    tevent_req_set_callback(subreq, ipa_sudo_get_cmds_connect_done, req);
+
+    return EAGAIN;
+}
+
+static void ipa_sudo_get_cmds_connect_done(struct tevent_req *subreq)
+{
+    struct ipa_sudo_get_cmds_state *state;
+    struct tevent_req *req;
+    int dp_error;
+    int ret;
+
+    /* req from ipa_sudo_get_cmds_send */
+    req = tevent_req_callback_data(subreq, struct tevent_req);
+    state = tevent_req_data(req, struct ipa_sudo_get_cmds_state);
+
+    ret = sdap_id_op_connect_recv(subreq, &dp_error);
+    talloc_zfree(subreq);
+
+    if (dp_error == DP_ERR_OFFLINE) {
+        talloc_zfree(state->sdap_op);
+        state->dp_error = DP_ERR_OFFLINE;
+        state->error = EAGAIN;
+        tevent_req_done(req);
+        return;
+    } else if (ret != EOK) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "IPA SUDO cmds connection failed - %s\n", 
+                                    strerror(ret));
+        goto fail;
+    }
+
+    DEBUG(SSSDBG_TRACE_FUNC, "IPA SUDO cmds connection successful\n");
+
+    struct sdap_attr_map *map = state->opts->ipa_sudocmds_map;
+
+    /* create attrs from map */
+    ret = build_attrs_from_map(state, map, SDAP_OPTS_SUDO_CMD, NULL, &state->attrs, NULL);
+    if (ret != EOK) {
+        goto fail;
+    }
+
+    DEBUG(SSSDBG_TRACE_FUNC, "Searching for IPA SUDO commands\n");
+
+    subreq = sdap_get_generic_send(state,
+                                   state->ev,
+                                   state->opts,
+                                   sdap_id_op_handle(state->sdap_op),
+                                   state->basedn,
+                                   state->scope,
+                                   state->filter,
+                                   state->attrs,
+                                   map,
+                                   SDAP_OPTS_SUDO_CMD,
+                                   state->timeout,
+                                   true);
+    if (subreq == NULL) {
+        goto fail;
+    }
+
+    tevent_req_set_callback(subreq, ipa_sudo_cmds_process, req);
+
+fail:
+    state->error = ret;
+
+    if (ret != EOK) {
+        tevent_req_error(req, ret);
+    }
+}
+
+static void ipa_sudo_cmds_process(struct tevent_req *subreq)
+{
+    struct ipa_sudo_get_cmds_state *state;
+    struct tevent_req *req;
+    int ret;
+
+    /* req from ipa_sudo_get_cmds_send */
+    req = tevent_req_callback_data(subreq, struct tevent_req);
+    state = tevent_req_data(req, struct ipa_sudo_get_cmds_state);
+ 
+    DEBUG(SSSDBG_TRACE_FUNC, "Receiving commands for IPA SUDO rules with "
+                             "base [%s]\n", state->basedn);
+
+    /* get IPA sudo commands */
+    ret = sdap_get_generic_recv(subreq, state, 
+                                &state->rules->ipa_cmds_count, 
+                                &state->rules->ipa_cmds);
+    talloc_zfree(subreq);
+    if (ret != EOK) {
+        goto fail;
+    }
+
+    ret = export_sudoers_cmds(state, 
+                              state->rules->sudoers, 
+                              state->rules->sudoers_count,
+                              state->rules->cmds_index, 
+                              state->rules->ipa_cmds, 
+                              state->rules->ipa_cmds_count);
+    if (ret != EOK) {
+        goto fail;
+    }
+
+    DEBUG(SSSDBG_TRACE_FUNC, "All IPA sudo rules successfully exported into "
+                             "the native LDAP SUDO scheme\n");
+
+fail:
+    if (ret == EOK) {
+        /* ipa_sudo_get_cmds_send */
+        tevent_req_done(req);
+    } else {
+        tevent_req_error(req, ret);
+    }
+}
diff --git a/src/providers/ipa/ipa_async_sudo_cmds.h b/src/providers/ipa/ipa_async_sudo_cmds.h
new file mode 100644
index 0000000000000000000000000000000000000000..20db4237a6a7a0fa41dc160aa0424a81051277ca
--- /dev/null
+++ b/src/providers/ipa/ipa_async_sudo_cmds.h
@@ -0,0 +1,39 @@
+/*
+    SSSD
+
+    Authors:
+        Michal Šrubař <xsruba03@stud.fit.vutbr.cz>
+
+    Copyright (C) 2014 Michal Šrubař
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef _IPA_ASYNC_SUDO_CMDS_H_
+#define _IPA_ASYNC_SUDO_CMDS_H_
+
+struct tevent_req *
+ipa_sudo_get_cmds_send(TALLOC_CTX *mem,
+                       struct sysdb_attrs **ipa_rules,
+                       int ipa_rules_count,
+                       struct be_ctx *be_ctx,
+                       struct sdap_id_conn_cache *conn_cache,
+                       struct sdap_options *opts);
+int ipa_sudo_get_cmds_recv(struct tevent_req *req,
+                               TALLOC_CTX *mem_ctx,
+                               size_t *reply_count,
+                               struct sysdb_attrs ***reply);
+
+#endif  // _IPA_ASYNC_SUDO_CMDS_H_
